/*****
*
*   ContourSegment.js
*
*   copyright 2001-2002, Kevin Lindsey
*   Based on Sven Moen's article "Drawing Dynamic Trees"
*
*****/

/*****
*
*   constructor
*
*****/
function ContourSegment(x, y, next) {
    this.offset = new Point2D(x, y);
    this.next   = next;
}


/*****
*
*   bridge
*
*****/
ContourSegment.prototype.bridge = function(p1, that, p2) {
    var offset = that.offset;
    var dx, dy;
    var r;

    dx = p2.x + offset.x - p1.x;
    if ( offset.x == 0 ) {
        dy = offset.y;
    } else {
        dy = dx * offset.y / offset.x;
    }

    r = new ContourSegment(dx, dy, that.next);
    this.next = new ContourSegment(0, p2.y + offset.y - dy - p1.y, r);

    return r;
};

