/*****
*
*   Utilities.js
*
*   copyright 2002, Kevin Lindsey
*
*****/

/*****
*
*   Globals
*
*****/
var tree;


/*****
*
*   buildTree
*
*****/
function buildTree(node, graph) {
    if ( tree == null ) {
        tree = makeTree(node);

        tree.layout();
        tree.plantTree(0,0);
        tree.realize(graph);

        var bbox = graph.getBBox();
        // Commented code centers graph in SVG window
        //var x_offset = -bbox.x + (innerWidth - bbox.width) / 2;
        //var y_offset = -bbox.y + (innerHeight - bbox.height) / 2;
        var x_offset = -bbox.x + (innerWidth - bbox.width) - 5;
        var y_offset = -bbox.y + 5;
        graph.setAttributeNS(
            null,
            "transform",
            "translate(" + x_offset + "," + y_offset + ")"
        );
    }
}


/*****
*
*   makeTree
*
****/
function makeTree(element) {
    var type = element.nodeType;
    var node;

    switch (type) {
        case (1):
            var name = element.tagName;
            var children = element.childNodes;
            
            node = new Node(name);
            for (var i = 0; i < children.length; i++) {
                var child = children.item(i)
                var child_node = makeTree(child);

                if ( child_node ) {
                    node.appendChild(child_node);
                }
            }
            break;
    }

    return node;
}
